/************************************************************************
 *	cam3.c       	 30-NOV-1992		Y.Takeuchi		*
 *									*
 *	CAMAC LAM Interrupt test (New)					*
 *									*
 *	cam3 [N_of_interrupt_source [loop_count [timeout]]]		*
 ************************************************************************/
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/file.h>
#include "camlib.h"

#define DEFN        11
#define DEFLOP      10
#define DEFTIMEOUT  10


/****************************
 * Main routine             *
 ****************************/
main(argc, argv)
int argc;
char *argv[];
{
    int i, n, mask, status;
    int nafenalam, nafdislam, nafclrlam;
    int dat, q, x;
    int loop, timeo;

/* Read options */
    n     = (argc > 1) ? atoi(argv[1]) : DEFN;
    loop  = (argc > 2) ? atoi(argv[2]) : DEFLOP;
    timeo = (argc > 3) ? atoi(argv[3]) : DEFTIMEOUT;


/* Initialize valiable */
    mask = 1 << (n - 1);
    nafenalam = NAF(n, 0, 26);
    nafdislam = NAF(n, 0, 24);
    nafclrlam = NAF(n, 0, 10);

/* Open and Initialize CAMAC */
    status = 0;
    status += CAM_Open("/k3922",1);
    status += CSETBR(1);
    status += CSETCR(0);
    status += CGENC();
    status += CGENZ();
    status += CREMI();

    if (status != 0) {
	printf("INIT. ERROR!\n");
	exit(1);
    }

/* Enable LAM */
    status = 0;
    status = CAMAC(nafenalam, &dat, &q, &x);
    status += CAM_EnableLAM(mask);
    if (status != 0) {
	printf("Enable LAM ERROR! N=%d  status=0x%x\n", n, status);
/*
	exit(2);
*/
    }

/********
 * loop *
 ********/
    printf("\n\n*** Now waiting LAM ... N=%d Loop=%d Timeout=%d sec\n\n",
	   n, loop, timeo / 100);

    for(i = 0; i < loop; i++) {

	if (CAM_WaitLAM(timeo))                  /* Wait event */
	    printf("Timeout !!     count=%d\n", i + 1);
	else
	    printf("Interrupted !! count=%d\n", i + 1);
	CAMAC(nafclrlam, &dat, &q, &x);    /* clear LAM */
/*
	CAMAC(NAF(11,0,8), &dat, &q, &x);
	printf("%d\n",q);
*/
    }
    CAM_DisableLAM();
    CAM_Close();

    printf("\n\n*** cam3 nomal end.\n\n");
}
